#pragma rtGlobals=1		// Use modern global access method.

//John Economides (7/25/2009)

Menu "Macros"                                  		//Add function to the macro list
	"Extract Spikes", ExtractSpikes()     
End

Function ExtractSpikes()
       //Function automatically pulls out spikes and writes them to individual waves
	String unitSourceName														//Set string varible for wave to operate on
	Prompt unitSourceName, "Unit Wave", popup WaveList("*",";","") 					//Set prompt for wave to operate on
	Variable posThresh=5															//Set variable for minimum peak voltage
	Prompt posThresh, "Minimum Positive Threshold (v)"								//Set variable for minimum peak voltage
	Variable negThresh=-5														//Set variable for minimum peak voltage
	Prompt negThresh, "Minimum Negative Threshold (v)"								//Set variable for minimum peak voltage
	Variable slidingWindowWidth=3
	Prompt slidingWindowWidth, "Points in Sliding Window"
	Variable minimumStep=.0005
	Variable startTime=0
	Prompt minimumStep, "Minimum Search Time to Next Spike (s)"
	Variable exSpikeWidth=.0015
	Prompt exSpikeWidth, "Extracted Spike Width (s)"
	Variable sampFreq=25000
	Prompt sampFreq, "Sampling Frequency (Hz)"
	DoPrompt "ExtractSpikes", unitSourceName, sampFreq, posThresh, negThresh, slidingWindowWidth, minimumStep, exSpikeWidth
	PauseUpdate; Silent 1
	
	if (V_Flag)
		return -1								// User canceled
	endif
	
	Variable exSpikePoints
	exSpikePoints=(exSpikeWidth/(1/sampFreq))
	NewDataFolder Extracted_Spikes
	MoveWave $unitSourceName, :Extracted_Spikes:
	SetDataFolder Extracted_Spikes
	KillWaves /Z SpkTimes
	Make /N=1 SpkTimes
	
	do	
		FindPeak /Q /B=('slidingWindowWidth') /M=('posThresh') /R=(startTime,rightx($unitSourceName)) $unitSourceName
		
			
		if (V_TrailingEdgeLoc==NaN)
		
			startTime+=.001													// execute if condition is TRUE
		else
			startTime=V_TrailingEdgeLoc+'minimumStep'						// execute if condition is FALSE
		endif
		
		//Extract/O $unitSourceName, $("spike" + num2str(V_PeakLoc)), x<(V_PeakLoc+(exSpikeWidth/2)) && x>(V_PeakLoc-(exSpikeWidth/2))
		
		//Duplicate/O/R=(V_PeakLoc-(exSpikeWidth*.25),V_PeakLoc+(exSpikeWidth*.75)) $unitSourceName, $("spike" + num2str(V_PeakLoc))
		Duplicate/O/R=(V_PeakLoc-(exSpikeWidth*.5),V_PeakLoc+(exSpikeWidth*.5)) $unitSourceName, $("spike" + num2str(V_PeakLoc))
		//Duplicate is 1000s of times faster than Extract!!!!!!!
		SetScale/P x 0,1/sampFreq,"", $("spike" + num2str(V_PeakLoc))
		DeletePoints floor(exSpikePoints), 2, $("spike" + num2str(V_PeakLoc))	
		
		SpkTimes[rightx(SpkTimes)]=V_PeakLoc
		InsertPoints rightx(SpkTimes),1, SpkTimes
		
	while (V_TrailingEdgeLoc<rightx($unitSourceName))
	startTime=0

	do	
		FindPeak /Q /N /B=('slidingWindowWidth') /M=('negThresh') /R=(startTime,rightx($unitSourceName)) $unitSourceName
		
			
		if (V_TrailingEdgeLoc==NaN)
		
			startTime+=.001												// execute if condition is TRUE
		else
			startTime=V_TrailingEdgeLoc+'minimumStep'						// execute if condition is FALSE
		endif
	
	
		//Extract/O $unitSourceName, $("spike" + num2str(V_PeakLoc)), x<(V_PeakLoc+(exSpikeWidth/2)) && x>(V_PeakLoc-(exSpikeWidth/2))
		
		Duplicate/O/R=(V_PeakLoc-(exSpikeWidth*.25),V_PeakLoc+(exSpikeWidth*.75)) $unitSourceName, $("spike" + num2str(V_PeakLoc))
		//Duplicate is 1000s of times faster than Extract!!!!!!!
		SetScale/P x 0,1/sampFreq,"", $("spike" + num2str(V_PeakLoc))
		DeletePoints floor(exSpikePoints), 2, $("spike" + num2str(V_PeakLoc))	
		
		SpkTimes[rightx(SpkTimes)]=V_PeakLoc
		InsertPoints rightx(SpkTimes),1, SpkTimes
		
	while (V_TrailingEdgeLoc<rightx($unitSourceName))
	
	KillStrings /A
	Extract/O SpkTimes, SpkTimesGoodTemp, SpkTimes[p]>0 // gets rid of NaNs and zeros left over from the loops above
	KillWaves spikeNaN, SpkTimes // kills illformed and inappropriately sized waves left over from loops above
	Rename SpkTimesGoodTemp, SpkTimes // renames the temporary wave to the correct name
	MoveWave $unitSourceName, root:
	SetDataFolder root:

End