#pragma rtGlobals=1		// Use modern global access method.

//John Economides (7/25/2009)

Menu "Macros"
	"PCA and Clustering/4", RunPCAandCluster()
End

Function RunPCAandCluster()
	
	Variable analysisType=2
	Prompt analysisType,"Analysis",popup,"KMeans;FP Clustering"
	Variable maxClusters=10
	Prompt maxClusters, "Maximum Number of FP Clusters"
	Variable numClassesKM=3
	Prompt numClassesKM, "Number of  Classes for KMeans"
	DoPrompt "PCA and Clustering", analysisType, maxclusters, numClassesKM
	PauseUpdate; Silent 1
	
	if (V_Flag)
		return -1								// User canceled
	endif
	
	String spikeNames
	spikeNames=WaveList("spi*",";","")
	Concatenate/O spikeNames, spkMatrix
	
	PCA/ALL/SRMT/SCMT spkMatrix
	Wave M_C
	Make/O/N=(numpnts(SpkTimes)) PC1, PC2, PC3
	ColorTab2Wave Rainbow256
	
	PC1[]=M_C[0][p]
	PC2[]=M_C[1][p]
	PC3[]=M_C[2][p]
	WMXYZToXYZTriplet(PC1,PC2,PC3, "xyzPC")
	
	if (analysisType == 1) //KMeans
	
		Duplicate/O xyzPC xyzPC4KM
		MatrixTranspose xyzPC4KM
	
		//KMeans/init=1/out=2/ter=1/dead=1/tern=1000/ncls=(numClassesKM) xyzPC4KM
		KMeans/init=3/out=2/ter=1/dead=2/ncls=(numClassesKM) xyzPC4KM

		Wave M_colors
		Wave W_KMMembers
		
		Duplicate/O W_KMMembers W_KMMembers_Sorted
		WMXYZTripletToXYZWaves(xyzPC,"PC1_Sorted", "PC2_Sorted", "PC3_Sorted")
		Sort W_KMMembers_Sorted, PC1_Sorted, PC2_Sorted, PC3_Sorted, W_KMMembers_Sorted
		
	
		Variable boundary1, boundary2, i=numClassesKM
		Variable cIndexKM=round(DimSize(M_colors,0)/numClassesKM)
	
		//Execute "NewGizmo"
		Execute "NewGizmo/T=\"Principal Components - KMeans\""
		Execute "MoveWindow 540.75,41.75,1069.5,521.75"
		Execute "ModifyGizmo setDisplayList=0, opName=clearColor, operation=clearColor, data={0.398,0.398,0.398,0}"
		Execute "ModifyGizmo euler={25,-25,0}"
		Display/W=(35.25,41.75,524.25,522.5) as "KMeans Clustering Results"
	
		do
	
			//boundary1=BinarySearch(W_KMMembers_Sorted,i)
			//boundary2=BinarySearch(W_KMMembers_Sorted,(i-1))
			
			boundary1=BinarySearch(W_KMMembers_Sorted,(i-1))
			boundary2=BinarySearch(W_KMMembers_Sorted,(i-2))
	
			Duplicate/O/R=[boundary2+1,boundary1] W_KMMembers_Sorted, $("W_KMMembers_"+ num2str(i))
			Duplicate/O/R=[boundary2+1,boundary1] PC1_Sorted $("PC1_"+ num2str(i))
			Duplicate/O/R=[boundary2+1,boundary1] PC2_Sorted $("PC2_"+ num2str(i))
			Duplicate/O/R=[boundary2+1,boundary1] PC3_Sorted $("PC3_"+ num2str(i))
			WMXYZToXYZTriplet($("PC1_"+ num2str(i)),$("PC2_"+ num2str(i)),$("PC3_"+ num2str(i)), ("xyzPC"+num2str(i)))
			string/G temp="xyzPC"+num2str(i)
			string/G scatNum="scatter"+(num2str((numClassesKM-i)))
			string/G cFrac
			//Wave M_colors
			//Wave W_KMMembers
			//sprintf cFrac,"ModifyGizmo ModifyObject=%s, property={color,%g,%g,%g,0}", scatNum, abs(enoise(1)),abs(enoise(1)),abs(enoise(1))
			sprintf cFrac,"ModifyGizmo ModifyObject=%s, property={color,%g,%g,%g,0}", scatNum, (M_colors[cIndexKM*i][0])/65535,(M_colors[cIndexKM*i][1])/65535,(M_colors[cIndexKM*i][2])/65535
			Execute "AppendToGizmo nextscatter=$temp"
			Execute "ModifyGizmo ModifyObject=$scatNum property={shape,1}"
			Execute "ModifyGizmo ModifyObject=$scatNum property={size,3}"
			Execute cFrac
			Execute "ModifyGizmo showAxisCue = 1"
			Extract/O SpkTimes, $("SpkTimes"+num2Str(i)), W_KMMembers==i
			Make/O/N=(numPnts($("SpkTimes"+num2Str(i)))) $("SpkIndex"+num2Str(i))=i
			AppendToGraph/L=L_spike/C=(M_colors[cIndexKM*i][0],M_colors[cIndexKM*i][1],M_colors[cIndexKM*i][2]) $("SpkIndex"+num2Str(i)) vs $("SpkTimes"+num2Str(i))
			ModifyGraph mode($("SpkIndex"+num2Str(i)))=3,marker($("SpkIndex"+num2Str(i)))=10,msize($("SpkIndex"+num2Str(i)))=5
			//Execute "ModifyGizmo ModifyObject=$scatNum property={color,0,0,0,0}"
			KillStrings temp, scatnum, cFrac
			
		
			Variable m=0   //begin Addition for Overlayed spikes
			string/G spkList=WaveList("spike*",";","")
			
				do
						if (W_KMMembers[m]==i)
							AppendToGraph/T/C=(M_colors[cIndexKM*i][0],M_colors[cIndexKM*i][1],M_colors[cIndexKM*i][2]) $(StringFromList(m,spkList))
						endif
					m+=1
				while (m<numPnts(W_KMMembers))	// end Addition for Overlayed Spikes
				
			i-=1
	
		while (i<=0)
		
		ModifyGraph axisEnab(L_spike)={0,0.4},freePos(L_spike)=0
		ModifyGraph axisEnab(left)={0.6,1}
		ModifyGraph lblPos(L_spike)=50;DelayUpdate
		Label L_spike "Unit Number"
		Label bottom "Time (s)"
		ModifyGraph lblPos(left)=50;DelayUpdate
		Label left "Voltage"
		Label top "Time (ms)\\u#2"
		SetAxis bottom 0,*
		ModifyGraph axOffset(top)=2
		ModifyGraph lblMargin(top)=25,lblLatPos=0
		SetDrawEnv fsize= 18;DelayUpdate
		DrawText -.01,-0.125,"Spike Waveforms"
		SetDrawEnv fsize= 18;DelayUpdate
		DrawText -.01,0.545,"Spike Times"
		ModifyGraph wbRGB=(56576,56576,56576),gbRGB=(56576,56576,56576)
		SetDrawLayer UserBack
		SetDrawEnv linethick= 0,fillfgc= (0,0,0)
		DrawRect 0,0.579281183932347,1.00191938579655,1.01902748414376
		SetDrawEnv linethick= 0,fillfgc= (0,0,0)
		DrawRect 0,-0.0169133192389006,1.00191938579655,0.422832980972516
		SetDrawLayer UserFront
		KillStrings spkList
		
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	elseif(analysisType == 2) //FP Clustering
	
		FPClustering/NOR/CM/MAXC=(maxClusters) xyzPC
		
		Wave M_colors
		Wave W_FPClusterIndex

		Duplicate/O W_FPClusterIndex W_FPClusterIndex_Sorted
		WMXYZTripletToXYZWaves(xyzPC,"PC1_Sorted", "PC2_Sorted", "PC3_Sorted")
		Sort W_FPClusterIndex_Sorted, PC1_Sorted, PC2_Sorted, PC3_Sorted, W_FPClusterIndex_Sorted
		
		//Wave M_colors
		//Wave W_FPClusterIndex

		Variable boundary3, boundary4, j=Wavemax(W_FPClusterIndex), numClassesFP=Wavemax(W_FPClusterIndex)
		Variable cIndexFP=round(DimSize(M_colors,0)/numClassesFP)
	
		Execute "NewGizmo/T=\"Principal Components - FP\""
		Execute "MoveWindow 540.75,41.75,1069.5,521.75"
		Execute "ModifyGizmo setDisplayList=0, opName=clearColor, operation=clearColor, data={0.398,0.398,0.398,0}"
		Execute "ModifyGizmo euler={25,-25,0}"
		Display/W=(35.25,41.75,524.25,522.5) as "FP Clustering Results"
		
		do
	
			boundary3=BinarySearch(W_FPClusterIndex_Sorted,j)
			boundary4=BinarySearch(W_FPClusterIndex_Sorted,(j-1))
	
			Duplicate/O/R=[boundary4+1,boundary3] W_FPClusterIndex_Sorted, $("W_FPClusterIndex_"+ num2str(j))
			Duplicate/O/R=[boundary4+1,boundary3] PC1_Sorted $("PC1_"+ num2str(j))
			Duplicate/O/R=[boundary4+1,boundary3] PC2_Sorted $("PC2_"+ num2str(j))
			Duplicate/O/R=[boundary4+1,boundary3] PC3_Sorted $("PC3_"+ num2str(j))
			WMXYZToXYZTriplet($("PC1_"+ num2str(j)),$("PC2_"+ num2str(j)),$("PC3_"+ num2str(j)), ("xyzPC"+num2str(j)))
			string/G temp="xyzPC"+num2str(j)
			string/G scatNum="scatter"+(num2str((Wavemax(W_FPClusterIndex)-j)))
			string/G cFrac
			//Wave M_colors
			//sprintf cFrac,"ModifyGizmo ModifyObject=%s, property={color,%g,%g,%g,0}", scatNum, abs(enoise(1)),abs(enoise(1)),abs(enoise(1))
			//sprintf cFrac,"ModifyGizmo ModifyObject=%s, property={color,%g,%g,%g,0}", scatNum, M_colors[round((256/numClassesFP))*j][0],M_colors[round((256/numClassesFP))*j][1],M_colors[round((256/numClassesFP))*j][2]
			sprintf cFrac,"ModifyGizmo ModifyObject=%s, property={color,%g,%g,%g,0}", scatNum, (M_colors[cIndexFP*j][0])/65535,(M_colors[cIndexFP*j][1])/65535,(M_colors[cIndexFP*j][2])/65535
			Execute "AppendToGizmo nextscatter=$temp"
			Execute "ModifyGizmo ModifyObject=$scatNum property={shape,1}"
			Execute "ModifyGizmo ModifyObject=$scatNum property={size,3}"			
			Execute cFrac
			Execute "ModifyGizmo showAxisCue = 1"
			Extract/O SpkTimes, $("SpkTimes"+num2Str(j)), W_FPClusterIndex==j
			Make/O/N=(numPnts($("SpkTimes"+num2Str(j)))) $("SpkIndex"+num2Str(j))=j
			AppendToGraph/L=L_spike/C=(M_colors[cIndexFP*j][0],M_colors[cIndexFP*j][1],M_colors[cIndexFP*j][2]) $("SpkIndex"+num2Str(j)) vs $("SpkTimes"+num2Str(j))
			ModifyGraph mode($("SpkIndex"+num2Str(j)))=3,marker($("SpkIndex"+num2Str(j)))=10,msize($("SpkIndex"+num2Str(j)))=5
			//Execute "ModifyGizmo ModifyObject=$scatNum property={color,0,0,0,0}"
			KillStrings temp, scatnum, cFrac
			
			Variable k=0   //begin Addition for Overlayed spikes
			string/G spkList=WaveList("spike*",";","")
			
				do
						if (W_FPClusterIndex[k]==j)
							AppendToGraph/T/C=(M_colors[cIndexFP*j][0],M_colors[cIndexFP*j][1],M_colors[cIndexFP*j][2]) $(StringFromList(k,spkList))
						endif
					k+=1
				while (k<numPnts(W_FPClusterIndex))	// end Addition for Overlayed Spikes
			
			j-=1
	
		while (j>=0)
		
		ModifyGraph axisEnab(L_spike)={0,0.4},freePos(L_spike)=0
		ModifyGraph axisEnab(left)={0.6,1}
		ModifyGraph lblPos(L_spike)=50;DelayUpdate
		Label L_spike "Unit Number"
		Label bottom "Time (s)"
		ModifyGraph lblPos(left)=50;DelayUpdate
		Label left "Voltage"
		Label top "Time (ms)\\u#2"
		SetAxis bottom 0,*
		ModifyGraph axOffset(top)=2
		ModifyGraph lblMargin(top)=25,lblLatPos=0
		SetDrawEnv fsize= 18;DelayUpdate
		DrawText -.01,-0.125,"Spike Waveforms"
		SetDrawEnv fsize= 18;DelayUpdate
		DrawText -.01,0.545,"Spike Times"
		ModifyGraph wbRGB=(56576,56576,56576),gbRGB=(56576,56576,56576)
		SetDrawLayer UserBack
		SetDrawEnv linethick= 0,fillfgc= (0,0,0)
		DrawRect 0,0.579281183932347,1.00191938579655,1.01902748414376
		SetDrawEnv linethick= 0,fillfgc= (0,0,0)
		DrawRect 0,-0.0169133192389006,1.00191938579655,0.422832980972516
		SetDrawLayer UserFront
		KillStrings spkList
						
	endif
	
End